#
# This script was written by Alexis de Bernis <alexisb@nessus.org>
# 
#
# See the Nessus Scripts License for details
#


if(description)
{
 script_id(10452);
 #script_cve_id("CVE-2000-????");
 
 name["english"] = "wu-ftpd SITE EXEC vulnerability";
 name["francais"] = "Vulnrabilit SITE EXEC de wu-ftpd";
 
 script_name(english:name["english"],
             francais:name["francais"]);
             
 desc["english"] = "
The remote ftp server does not sanitize properly the argument of
the SITE EXEC command.
It may be possible for a remote attacker
to gain root access.

Solution : Upgrade your wu-ftpd server (<= 2.6.0 are vulnerables)
or disable any access from untrusted users (especially anonymous).
A corrected 2.6.1 should be available from the wu-ftpd team.

Risk factor : Serious";
                 
                 
desc["francais"] = "
Le serveur ftp ne vrifie pas correctement les arguments de la
commande SITE EXEC.
Il est possible d'obtenir un accs root en exploitant ce bug.

Solution : Mettez  jour votre serveur wu-ftpd (<= 2.6.0 are vulnerables)
ou limitez l'accs aux utilisateurs de confiance (enlevez l'accs anonyme). 
Une version 2.6.1 corrige est disponible sur le site officiel wu-ftpd.

Facteur de risque : Srieux";
                     
 script_description(english:desc["english"],
                    francais:desc["francais"]);
                    
 
 script_summary(english:"Checks if the remote ftp sanitizes the SITE EXEC command",
                francais:"Dtermine si le serveur ftp distant vrifie la commande SITE EXEC");
 script_category(ACT_ATTACK);
 script_family(english:"FTP", francais:"FTP");

 
 script_copyright(english:"This script is Copyright (C) 2000 A. de Bernis",
                  francais:"Ce script est Copyright (C) 2000 A. de Bernis");
                  
 script_dependencie("find_service.nes", "ftp_anonymous.nasl");
 script_require_keys("ftp/anonymous");
 script_require_ports("Services/ftp", 21);
 exit(0);
}

#
# The script code starts here : 
#

# First, we need anonymous access
anon = get_kb_item("ftp/anonymous");
if(!anon)exit(0);

port = get_kb_item("Services/ftp");
if(!port)port = 21;


# Connect to the FTP server
soc = open_sock_tcp(port);
if(soc)
{
 if(ftp_log_in(socket:soc, user:"anonymous", pass:"nessus@nessus.org"))
 {
 
  # We are in
 
  port = ftp_get_pasv_port(socket:soc);
  soc2 = open_sock_tcp(port);
  if(soc2)
  {
   c = string("SITE EXEC %p \r\n");
   send(socket:soc, data:c);
   b = recv(socket:soc, length:6);
   if(b == "200-0x") security_hole(port);
   close(soc2);
  }
  quit = string("QUIT\r\n");
  send(socket:soc, data:quit);
  close(soc);
 }
}
